#include "Handler.h"

void Handler::ZigBeeRx_Handler(uint8_t* mar)
{
	switch (mar[1])
	{
	case 0x02:        //
		MainCarRx_Handler(mar);       //Ӧ
		break;
	case 0x03:        //բ־
		break;
	case 0x04:        //LEDʾ־޷أ
		break;
	case 0x05:        //峵־B
		break;
	case 0x06:        //־
		break;
	case 0x07:        //ⱨ־
		break;
	case 0x08:        //TFTʾ־B
		break;
	case 0x09:        //־
		break;
	case 0x0A:        //߳־
		break;
	case 0x0B:        //TFTʾ־A
		break;
	case 0x0C:        //ETCϵͳ־
		break;
	case 0x0D:        //峵־A
		break;
	case 0x0E:        //ͨƱעA 
		break;
	case 0x0F:        //ͨƱ־B
		break;
	default:
		break;
	}
}

void Handler::OpenMVRx_Handler(uint8_t* mac)
{
	switch (mac[2])
	{
	case 0x91:        //

		break;
	case 0x92:        //άʶ

		break;
	default:
		break;
	}
}

void Handler::MainCarRx_Handler(uint8_t* com)
{
	switch (com[2])
	{
	case 0x01:                                         //ֹͣ
		DCMotor.Stop();
		break;
	case 0x02:                                        //ǰ
		DCMotor.Go(com[3], (com[4] + (com[5] << 8)));
		ZigBee_back[2] = 0x03;
		break;
	case 0x03:                                        //
		DCMotor.Back(com[3], (com[4] + (com[5] << 8)));
		ZigBee_back[2] = 0x03;
		break;
	case 0x04:                                        //ת
		DCMotor.TurnLeft(com[3]);
		ZigBee_back[2] = 0x02;
		break;
	case 0x05:                                        //ת
		DCMotor.TurnRight(com[3]);
		ZigBee_back[2] = 0x02;
		break;
	case 0x06:                                        //ѭ
		DCMotor.CarTrack(com[3]);
		ZigBee_back[2] = 0x00;
		break;
	case 0x07:                                        //
		Command.Judgment(Command.command01);                        //У                
		ExtSRAMInterface.ExMem_Write_Bytes(Command.command01, 8);   //
		break;
	case 0x10:                                       //
		infrare_com[0] = com[3];
		infrare_com[1] = com[4];
		infrare_com[2] = com[5];
		break;
	case 0x11:                                       //
		infrare_com[3] = com[3];
		infrare_com[4] = com[4];
		infrare_com[5] = com[5];
		break;
	case 0x12:                                        //ͺ
		Infrare.Transmition(infrare_com, 6);
		break;
	case 0x20:                                        //ת
		if (com[3] == 0x01)
			LED.LeftTurnOn();
		else
			LED.LeftTurnOff();
		if (com[4] == 0x01)
			LED.RightTurnOn();
		else
			LED.RightTurnOff();
		break;
	case 0x30:                                        //
		if (com[3] == 0x01)
			BEEP.TurnOn();
		else
			BEEP.TurnOff();
		break;
	case 0x40:                                        //
		break;
	case 0x50:                                        //LCDͼƬϷҳ
		Command.Judgment(Command.command13);
		ExtSRAMInterface.ExMem_Write_Bytes(Command.command13, 8);
		break;
	case 0x51:                                        //LCDͼƬ·ҳ
		Command.Judgment(Command.command14);
		ExtSRAMInterface.ExMem_Write_Bytes(Command.command14, 8);
		break;
	case 0x61:                                        //Դһ
		Infrare.Transmition(Command.HW_Dimming1, 4);
		break;
	case 0x62:                                        //ԴӶ
		Infrare.Transmition(Command.HW_Dimming2, 4);
		break;
	case 0x63:                                        //Դ
		Infrare.Transmition(Command.HW_Dimming3, 4);
		break;
	case 0x80:                                        //ӳл                                       
		if (com[3] == 0x01)
		{
			sendflag = 0x01;                             //ϴӳ
		}
		else
		{
			sendflag = 0x00;                              //رϴӳ
		}
	case 0x91:
		if (com[3] == 0x03)                               //
		{
			//Servoangle_control(com[4]);
		}
		break;
	default:
		break;
	}
}

void Handler::Key_0()
{
	BEEP.TurnOn();
	delay(50);
	BEEP.TurnOff();
	OpenMVOpt::Servo_Control(-60);
	OpenMVOpt::OpenMV_Track(50);
	DCMotor.TurnLeft_Code(80, 760);
}

void Handler::Key_1()
{
	BEEP.TurnOn();
	delay(50);
	BEEP.TurnOff();
	delay(50);
	OpenMVOpt::Servo_Control(0);
}

void Handler::Key_2()
{
	DebugOpt::DebugRun();
}

void Handler::Key_3()
{
	DebugOpt::DebugServo();
}

void Handler::KEY_Handler(uint8_t k_value)
{
	switch (k_value)
	{
	case 1:
		Key_0();
		break;
	case 2:
		Key_1();
		break;
	case 3:
		Key_2();
		break;
	case 4:
		Key_3();
		break;
	}
}
